/*
 * Task 1 - AD Converter usage
 */

#include <msp430.h> 

const unsigned char Tabel[] =
{
	/*    xabcdefg */
		0b01111110,
		0b00110000,
		0b01101101,
		0b01111001,
		0b00110011,
		0b01011011,
		0b01011111,
		0b01110000,
		0b01111111,
		0b01111011,
		0b01110111,
		0b00011111,
		0b01001110,
		0b00111101,
		0b01001111,
		0b01000111
};
int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* 7-seg LED display initialization */
    P11DIR |= BIT1;
    P11OUT &= ~BIT1;
    P6DIR |= ~BIT7;

    /* AD converter initialization */
    /* AD converter potentiometer pin */
    P7DIR &= ~BIT6;    //This pin is connected to channel No 14 of AD converter
    P7SEL |= BIT6;

    ADC12CTL0 = ADC12ON;        //Turn on AD convertor core
    ADC12CTL1 |= ADC12SHS_0     //AD conversion is initiated by ADC12SC bit
              | ADC12SHP        //SAMPCON signal is sourced from the sampling timer
              | ADC12SSEL_0     //AD converter core use internal clock source
              | ADC12CONSEQ_0;  //AD converter core is in single channel single conversion mode

    ADC12MCTL0 |= ADC12INCH_14; //Select channel 14 as channel for conversion
    ADC12IE |= ADC12IE0;        //Enable AD converter interrupt
    ADC12CTL0 |= ADC12ENC;      //Enable AD conversion

    /* Button initialization */
    P2DIR &= ~BIT7;
    P2IE |= BIT7;
    P2IES |= BIT7;

    __bis_SR_register(GIE);

    while(1);
}

void __attribute__((interrupt(PORT2_VECTOR))) p2isr()
{

	__delay_cycles(10000);
	if (P2IFG & BIT7) {
		if (!(P2IN & BIT7)) {
			ADC12CTL0 |= ADC12SC; //Start AD conversion
		}
		P2IFG &= ~BIT7;
	}
}

void __attribute__((interrupt(ADC12_VECTOR))) adc12isr()
{
	switch (ADC12IV) {
	case 6:
		P6OUT = Tabel[(ADC12MEM0 >> 8) & 0x0f];
		break;
	default:
		break;
	}
}
