#include <msp430.h> 

/*
 * main.c
 */
int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* inicijalizacija tastera */
    P2DIR &= ~BIT7;
    P2IE |= BIT7;		/* prekid na P2.7 */
    P2IES |= BIT7;		/* prekid na silaznu */
	
    /* inicijalizacija tajmera */
    P4DIR |= BIT3;		/* P4.3 izlazni */
    P4SEL |= BIT3;		/* P4.3 koristi TB0.3 */

    TB0CCR0 = 0x0f;		/* period brojanja */
    TB0CCR3 = 0x07;		/* inicijalni duty ratio */
    TB0CCTL3 = OUTMOD_7;	/* reset/set mod */
    TB0CTL = TBSSEL__ACLK | MC__UP;		/* ACLK izvor, broji u UP modu */

    __bis_SR_register(GIE);

    while(1);
}

void __attribute__((interrupt(PORT2_VECTOR))) p2isr()
{
	__delay_cycles(10000);
	if (P2IFG & BIT7) {
		if (!(P2IN & BIT7)) {
			char tmp = TB0CCR3;
			tmp = (tmp + 1) & 0x0f;
			TB0CCR3 = tmp;
		}
		P2IFG &= ~BIT7;
	}
}
