#include <msp430.h>
#include "function.h"

#define TA2HZPERIOD (8191)
#define TBPERIOD	(0x0F)
#define TBDUTY		(0x07)

unsigned int adc_result;

/*
 * main.c
 */
int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* podesavanje LED displeja */
    P6DIR |= ~BIT7;				// segmenti
    P11DIR |= BIT1;				// selektovan prvi displej
    P11OUT &= ~BIT1;			// ukljucen prvi displej

    /* podesavanje A/D konvertora */
    P7SEL |= BIT6;				// selektovan A/D kanal A14
    ADC12CTL0 = ADC12ON;		// ukljucen ADC12
    ADC12CTL1 = ADC12SHS_1 + ADC12CONSEQ_2;	// sample/hold vreme diktira SHS signal
    ADC12MCTL0 = ADC12INCH_14;	// vrsi se akvizicija kanala 14
    ADC12CTL0 |= ADC12ENC;		// dozvola konverzija

    /* podesavanje tajmera za A/D */
    TA0CCTL0 = OUTMOD_4;		// outmod = toggle
    TA0CCR0 = TA2HZPERIOD;		// 2Hz
    TA0CTL = TASSEL_1 + MC_1;	// ACLK, up mode

    /* podesavanje PWM-a za diodu */
    P4DIR |= BIT3;				// seletovana dioda
    P4SEL |= BIT3;				// tajmer upravlja diodom
    TB0CCR0 = TBPERIOD;			// PWM period
    TB0CCTL3 = OUTMOD_7;		// CCR3 reset/set
    TB0CCR3 = TBDUTY;			// CCR3 PWM duty cycle
    TB0CTL = TBSSEL_1 + MC_1;	// ACLK, up mode
	
    /* glavna petlja */
    while (1) {
    	while (!(ADC12IFG & BIT0));		// ceka da se zavrsi konverzija
    	adc_result = ADC12MEM0;			// ocitava rezultat konverzije
    	WriteLed((adc_result >> 8) & 0x0F);
    	TB0CCR3 = (adc_result >> 8) & 0x0F;
    }
}
